#!/usr/local/bin/ruby
#
# file name: login_table.cgi
#
#   cgi for login table.
#   
#
#   0.00 2013-05-30 S.Yamane
#
#
######################################################################
require 'tempfile'
require 'fileutils'
require 'cgi'
require 'rexml/document'
require 'time'
require '../lib/pharma_db_lib'

Login_table = 'login'

def change_db()
  change_db_cmd = nil
  db_soft = PharmaDbLib.get_db_soft()
  	STDERR.print "db_soft=",db_soft,"\n"
  case db_soft
  when /mysql/
    change_db_cmd= "connect pharma_system;"
  when /postgres/
    change_db_cmd = "\\c pharma_system\n"
  end
  return change_db_cmd
  
end
#
#  database name: login
#    
#
def list()

  change_db_cmd = change_db()

  sql_cmd =<<-SQL 
    select userid,password,name,perm1,remark
    from #{Login_table}
    order by userid 
    ;
  SQL
  sql_cmd = change_db_cmd + sql_cmd

  datas = PharmaDbLib.exec_sql(sql_cmd)

  return datas
end
#
#
def check_userid(userid)
  change_db_cmd = change_db()
  sql_cmd =<<-SQL 
    select userid,password,name,perm1,perm2,remark
    from #{Login_table}
    where userid = '#{userid}';
  SQL
  sql_cmd = change_db_cmd + sql_cmd
  datas = PharmaDbLib.exec_sql(sql_cmd)
  
end
#
#
def add(userid,password,name,perm1,perm2,remark)

  change_db_cmd = change_db()

  sql_cmd =<<-SQL
  insert into #{Login_table}
  ( userid,password,name,perm1,perm2,remark)
  values
  ( '#{userid}','#{password}','#{name}','#{perm1}','#{perm2}','#{remark}')
  ;
  SQL

  sql_cmd = change_db_cmd + sql_cmd

  	STDERR.print  sql_cmd
  datas = PharmaDbLib.exec_sql(sql_cmd)

  return datas

end
#
def update(userid,password,name,perm1,perm2,remark)


  sql_cmd =<<-SQL
  update #{Login_table}
  set
  password ='#{password}'
  ,name ='#{name}'
  ,perm1 ='#{perm1}'
  ,perm2 ='#{perm2}'
  ,remark ='#{remark}'
  where userid = '#{userid}'
  ;
  SQL

  change_db_cmd = change_db()
  sql_cmd = change_db_cmd + sql_cmd

  datas = PharmaDbLib.exec_sql(sql_cmd)

  return datas
end
#
#
#
def delete(userid)

  
  sql_cmd =<<-SQL
  delete from #{Login_table}
  where userid='#{userid}';
  SQL

  change_db_cmd = change_db()
  sql_cmd = change_db_cmd + sql_cmd

  datas = PharmaDbLib.exec_sql(sql_cmd)
  return datas

end

#
#
#########################################################
#
# main
#
#  flag=check userid=p1234567
#  flag=add data=p1234567,12345,yamane,1,2,test
#  xxxflag=update userid=p1234567 data=12345,yamane,1,2,test
#  flag=update userid=p1234567 userid=12345 password=aaaap name=yamane perm1=admin perm2= remark="test"
#  flag=delete userid=p1234567
#  flag=list
#  flag=test
#
#########################################################

cgi = CGI.new

PharmaDbLib.init();

flag = cgi['flag']
userid = cgi['userid']
name = cgi['name']
password = cgi['password']
perm1 = cgi['perm1']
perm2 = cgi['perm2']
remark = cgi['remark']

print cgi.header("content-type"=>"text/html","charset"=>"UTF-8")

case flag
when "test"
  userid = "p1234567"
  password = "12345"
  name = "yamane"
  perm1 = "admin"
  perm2 = ""
  remark = "test user"
  
  change_db_cmd = change_db()
  print "  change_db_cmd=",change_db_cmd,"\n"

  print "  exec list\n"
  datas = list()
  for dd in datas
    dds = dd.join("\t")
    print dds.strip,"\n"
  end

  print "  exec check_userid\n"
  data = check_userid(userid)
  print "check_userid=",data

  delete(userid)

  add(userid,password,name,perm1,perm2,remark)
  update(userid,password,name,perm1,perm2,remark)


when "list"
  datas = list()
when "check"
  datas = check_userid(userid)
when "add"
 
  datas = add(userid,password,name,perm1,perm2,remark)
when "update"
  
  datas = update(userid,password,name,perm1,perm2,remark)
when "delete"
  datas = delete(userid)
else
  STDERR.print "ERROR! flag=[list,create]\n"
  exit
end

for dds in datas
  print dds.join("\t"),"\n"
end


#
#
#
