#!/usr/local/bin/ruby
#
# file name: table_maintain_cgi_v0.02.rb
#
#   cgi for table create & listing.
#   
#
#   0.00 2013-05-08 S.Yamane
#   0.01 2013-05-21 s.yamane added mysql
#
#
######################################################################
require 'tempfile'
require 'fileutils'
require 'cgi'
require 'rexml/document'
require 'time'
require '../lib/pharma_db_lib'
#require 'lib/pharma_postgres_lib'


#
#  key1,key2....,xml_data,datetime のテーブルを作成する。
#  text の場合は、varchar(64)に固定する。
#  
#  flag=create table_name=test_table tabel_form="machine_no,varchardate,date"
#
#    seq_id 
#    key1  type
#    key2  type
#	..
#    xml_data xml
#    upto_date timestamp
#
def create_table( table_name, table_form )
		STDERR.print "exec create table,",table_form,"\n"
  char_size = 64
  colunm_data = ""
  d_key_names = []
  for dd in table_form.split(":")
	  p dd
     name,type = dd.split(",")
     d_key_names << name
    if ( type =~ /varchar/ ) then
      type = type + "(#{char_size})"
    end
    colunm_data += ",#{name}   #{type}\n"
  end
  key_names = d_key_names.join(",")

  db_soft = PharmaDbLib.get_db_soft()
  case db_soft
  when /postgres/

    sql_cmd =<<-SQL 
    create table #{table_name}
    (
    seq_id	SERIAL  unique	not null
    #{colunm_data}
    ,xml_data   xml not null
    ,upto_date	timestamp not null
    ,PRIMARY KEY( #{key_names} )
    )
   SQL
  when /mysql/
    colunm_data.chomp!()
    sql_cmd =<<-SQL 
    create table #{table_name}
    (
    seq_id  int not null auto_increment
    #{colunm_data}
    ,xml_data   text
    ,upto_date timestamp 
    ,PRIMARY KEY( seq_id,#{key_names} )
    );
   SQL
  end
    ##,upto_date	timestamp
    ##,PRIMARY KEY( #{key_names} )

  	STDERR.print "db_soft=\n", db_soft,"\n"
  	STDERR.print "sql_cmd=\n", sql_cmd,"\n"

  datas = PharmaDbLib.exec_sql(sql_cmd)

  return #datas
end
#
#
def info_table(table_name)
  d_column = []
  d_column << table_name

  db_soft = PharmaDbLib.get_db_soft()
  case db_soft
  when /postgres/
    sql_cmd =<<-SQL 
      \\d #{table_name}
    SQL
    datas = PharmaDbLib.exec_sql(sql_cmd)

    for dds in datas
      column,type,modifiers = dds
      d_column << column
    end
  when /mysql/
    sql_cmd =<<-SQL 
      show columns from #{table_name};
    SQL
    datas = PharmaDbLib.exec_sql(sql_cmd)
    for dds in datas
      column,type,modifiers = dds
      d_column << column
    end

  end

  return d_column

end
#
def list_table( )

  table_names = []
  db_soft = PharmaDbLib.get_db_soft()
  case db_soft
  when /postgres/
    sql_cmd =<<-SQL 
      \\dt
    SQL
    datas = PharmaDbLib.exec_sql(sql_cmd)
    for dds in datas
      aa,table_name,table,owner = dds
      next if table_name == nil
      table_names << table_name
    end
  when /mysql/
    sql_cmd =<<-SQL 
      show tables;
    SQL
    datas = PharmaDbLib.exec_sql(sql_cmd)
    for dds in datas
      table_names << dds.shift
    end
  end
  return table_names

end
#
#
def check_table( table_name )
  sql_cmd =<<-SQL 
    \\d #{table_name}
  SQL
  datas = PharmaDbLib.exec_sql(sql_cmd)
end
#########################################################
#
# main
#
#  flag=create table_name=test_table table_form="machine_no,varchar;work_date,date"
#  flag=list
#
#########################################################

cgi = CGI.new

PharmaDbLib.init();

flag = cgi['flag']
table_name = cgi['table_name']
table_form = cgi['table_form']

print cgi.header("content-type"=>"text/html","charset"=>"UTF-8")

if  ( flag == "list" ) then
  #datas = list_table()
  #for dd in datas
  #  aa,table_name,table,owner = dd
  table_names =  list_table()
  for table_name in table_names
    d_column = info_table(table_name)
    data = d_column.join("\t")
    print data.strip,"\n"
  end


elsif ( flag == "create") then
  if ( table_name.size == 0 ) then
    STDERR.print "ERROR!: set table_name\n"
    exit
  end
  datas = create_table(table_name, table_form)
else
  STDERR.print "ERROR! flag=[list,create]\n"
  exit
end


#
#
#
