#!/usr/local/bin/ruby
#
# file name:pharma_db_lib.rb
#
# 0.01 2013-05-20 s.yamane created
# 1.00 2013-08-23 s.yamane change db_info.yml format to one site only from multi site.
# 1.10 2013-10-15 s.yamane re added get_db_soft
# 1.20 2013-11-06 s.yamane re added check_table,check_column
#
#
#
require "mysql"
require "yaml"
require "socket"

module PharmaDbLib
module_function

  Sql_conf_yaml = "../conf/db_info.yml" \
	  			if defined?(Sql_conf_yaml) == nil

  def init()


    #@db_soft = "mysql"
    #@db_host = "localhost"
    #@db_user = "pharma-sc"
    #@db_passwd = "pharmapass"

    #@db_name = "pharma_db"
    #@db_port = "3306"

    
     yaml_data = File.read(Sql_conf_yaml)
     dds = YAML.load(yaml_data)


     h_data = dds["db_param"]
     @db_soft   = h_data["db_Soft"]
     @db_host   = h_data["db_Host"]
     @db_user   = h_data["db_User"]
     @db_passwd = h_data["db_Pass"]
     @db_name   = h_data["db_Name"]
     @db_port   = h_data["db_Port"]
     @db_cli_path = h_data["db_Ctl_Path"]


     if ( @db_soft != "mysql" ) then
         STDERR.print "Error db_soft #{@db_soft}!!\n"
	 exit
     end

  end
  #
  def list_param
     STDERR.print "db_host=",@db_host,"\n"
     STDERR.print "db_user=",@db_user,"\n"
     STDERR.print "db_passwd=",@db_passwd,"\n"
     STDERR.print "db_name=",@db_name,"\n"
     STDERR.print "db_port=",@db_port,"\n"
     STDERR.print "db_soft=",@db_soft,"\n"
     STDERR.print "db_lic_path=",@db_cli_path,"\n"

  end
  #
  def get_db_soft()
    return @db_soft
  end

  def check_table(table_name)
      
    case @db_soft
    when /postgres/
       # for postgres
       sql_cmd =<<-SQL
         SELECT relname FROM pg_class WHERE relkind = 'r' AND 
 	 relname = '#{table_name}'
       SQL

    when 'mysql'
       # for mysql
       sql_cmd =<<-SQL
         show tables like '#{table_name}'
       SQL
    end

    datas = exec_sql(sql_cmd)
    if ( datas.size == 0 ) then
 	  ##h_error["table_name"] = "#{table_name}テーブルがありません!!" 
          flag = false
    else
  	  flag = true
    end
  	return flag
  end

  def check_column(table_name,column)
    case @db_soft
    when /postgres/
      sql_cmd =<<-SQL
          SELECT attname 
	  FROM pg_class , pg_attribute, pg_type
	  WHERE relkind = 'r' 
	  and attname = '#{column}'
	  AND relname = '#{table_name}'
	  AND attrelid = 
	    (select relid from pg_stat_all_tables where relname = '#{table_name}')
	  AND attnum      > 0
	  AND pg_type.oid = atttypid;
      SQL
    when 'mysql'
      sql_cmd =<<-SQL
      show columns from #{table_name} where field = '#{column}';
      SQL
    end

      datas = exec_sql(sql_cmd)
      		STDERR.print sql_cmd,"\n"
      		STDERR.print datas,"\n"
      if ( datas.size == 0 ) then
	flag = false
      else
  	flag = true
      end
    return flag
  end
  #

  #
  #
  #
  def exec_sql_mysql(sql_cmd)

    client = Mysql.connect(@db_host,@db_user,@db_passwd,@db_name)
    if ( !client ) then
	    STDERR.print "connect error!!"
	    exit
    end
    res = client.query(sql_cmd)

    datas = []
    if ( res != nil ) then
      res.each do | line |
        datas << line
      end
    end

    client.close()

    return datas

  end

  def exec_sql_postgres(sql_cmd)

    temp = Tempfile.new( "ppls-sql_#{$$}.sql")
    sql_file = temp.path() 
    temp.print sql_cmd
    temp.close()

    cmd = "#{@db_cli_path} -U #{@db_user} -d #{@db_name} -h #{@db_host} -p #{@db_^ort} -t "
    cmd = cmd + " -f \"#{sql_file}\""
		#
		#

    res = `#{cmd}`

    datas = []
    res.each do | line |
      line.chomp()
      next if line.size == 0
      datas << line
    end

    return datas

  end
  #
  #
  def exec_sql(sql_cmd)
    case @db_soft
    when 'mysql'
      return exec_sql_mysql(sql_cmd)
    when 'postgres'
      return exec_sql_postgres(sql_cmd)
    else
      STDERR.print "error @db_soft =",@db_soft,"\n"
      return
    end
  end
  #
  #

end   # end of module

####################################################################
#
#  main
#    for check
####################################################################
if __FILE__ == $0

  #sql_file = ARGV.shift
  #sql_cmd = File.read(sql_file)
  sql_cmd =<<-SQL
    select * from login;
  SQL

	print "\n sql_cmd=",sql_cmd,"\n"

  PharmaDbLib.init()
  PharmaDbLib.list_param()
  datas = PharmaDbLib.exec_sql(sql_cmd)
  for dds in datas
    print dds.join("\t"),"\n"
  end
    
end

