#!/usr/local/bin/ruby
#
# file name:pharma_mysql_lib.rb
#
# 0.01 2013-05-15 s.yamane created
#
#
#
require "mysql"
require "yaml"
require "socket"

module PharmaMysql
module_function

  Sql_conf_yaml = "../conf/db_info.yml" \
	  			if defined?(Sql_conf_yaml) == nil


  def init()


    #@db_soft = "mysql"
    #@db_host = "localhost"
    #@db_user = "pharma-sc"
    #@db_passwd = "pharmapass"

    #@db_name = "pharma_db"
    #@db_port = "3306"

    # for debugg
    
    host_name = Socket.gethostname
    ip_address = IPSocket.getaddress(host_name)
    ip_address.gsub!(/:/,".")

    if ( host_name == "solaris-01" ) then
      ip_address = "192.168.24.58"
    end

     	STDERR.print host_name,"\n"
     	STDERR.print ip_address,"\n"

     unless ( File.exist?(Sql_conf_yaml) ) then
         STDERR.print "Error #{Sql_conf_yaml} not exists!!\n"
         exit 1
     end

     yaml_data = File.read(Sql_conf_yaml)
     dds = YAML.load(yaml_data)


     if ( dds[ip_address] == nil ) then
         STDERR.print "Error no parameter at #{ip_address}!!\n"
         exit 1
     end

     h_data = dds[ip_address]
     @db_soft   = h_data["db_Soft"]
     @db_host   = h_data["db_Host"]
     @db_user   = h_data["db_User"]
     @db_passwd = h_data["db_Pass"]
     @db_name   = h_data["db_Name"]
     @db_port   = h_data["db_Port"]

     if ( @db_soft != "mysql" ) then
         STDERR.print "Error db_soft #{@db_soft}!!\n"
	 exit
     end

  end
  #
  def list_param
     STDERR.print "db_host=",@db_host,"\n"
     STDERR.print "db_user=",@db_user,"\n"
     STDERR.print "db_passwd=",@db_passwd,"\n"
     STDERR.print "db_name=",@db_name,"\n"
     STDERR.print "db_port=",@db_port,"\n"
     STDERR.print "db_soft=",@db_soft,"\n"

  end
  #
  #
  #
  def exec_sql(sql_cmd)

    client = Mysql.connect(@db_host,@db_user,@db_passwd,@db_name)
    #client = Mysql::new("localhost", "root", "", "pharma_db" )
    if ( !client ) then
	    STDERR.print "connect error!!"
	    exit
    end
    res = client.query(sql_cmd)

    datas = []
    res.each do | line |
      datas << line
    end

    client.close()

    return datas

  end

end   # end of module

####################################################################
#
#  main
#
####################################################################
if __FILE__ == $0

  sql_file = ARGV.shift
  #sql_cmd = File.read(sql_file)
  sql_cmd =<<-SQL
  select * from login;
  SQL

  PharmaMysql.init()
  PharmaMysql.list_param()
  datas = PharmaMysql.exec_sql(sql_cmd)
  for dds in datas
    print dds.join("\t"),"\n"
  end
    
end

