#!/usr/bin/ruby
#
#  file name: pharma_ods.rb
#
#  0.00 created s.yamane
#  0.10 2013-07-01 s.yamane added textarea
#
#
$LOAD_PATH.push('/home/pharma-sc/lib/ruby/gem/gems/json-1.8.0/lib')
$LOAD_PATH.push('/home/pharma-sc/lib/ruby/gem/gems/zip-2.0.2/lib')
require "rexml/document"
require "json"
#require "json/lexer"
#require "zip/zipfilesystem"
#
module PharmaODS
module_function
#
#  cell内の文字列を取り出す。
#

def get_cel_text(cell)
      data =  nil
      cell.elements.collect("text:p") {| text_p |
	data = ""
        text_p.collect { |node|
		#print "                           ",node.class," node=",node,"\n"
           if ( node.class.to_s =~ /Text/i) then
		     STDERR.print "       Text node=     ",node.to_s,"\n"
             data = data + node.to_s
           else
		   STDERR.print "  node ",node.text,"\n"
             text_data = node.text  
	     if ( text_data != nil ) then
               data = data + node.text
             end
           end
        }
          STDERR.print "****  data.class=",data.class," data = ",data,"\n"

      }
      return data
end
#
#  @,save_f1,text,dbkey
#  @,db_list,db_listbox,machine,aa=bb,cc=dd,machine_no
#
def set_format(d_datas)
	STDERR.print "               aa  d_datas=",d_datas,"\n"
  d_datas.shift()	# @を取る。
  format_key = d_datas.shift()
	STDERR.print "               aa  format_key=",format_key,"\n"
  next if format_key =~ /^%/

  type = d_datas.shift()
  html_format = type.dup
  dbkey = ""
  case type

  when "save_button"
    values = d_datas.shift()
    html_format = html_format + "{" + values + "}"

  when "load_button"
    values = d_datas.shift()
    html_format = html_format + "{" + values + "}"

  when "db_table"
    values = d_datas.shift()
    html_format = html_format + "{" + values + "}"

  when "textarea"
    dbkey = d_datas.shift()
  when "text"
    dbkey = d_datas.shift()
  when "date"
    dbkey = d_datas.shift()
  when "time"
    dbkey = d_datas.shift()
  when "listbox"
    values = d_datas.shift()
    html_format = html_format + "{" + values + "}"
    dbkey = d_datas.shift()
  when "radio"
    radio_data = d_datas.shift()
    html_format = html_format + "{" + radio_data + "}"
    dbkey = d_datas.shift()
  when "check_box"
    values = d_datas.shift()
    html_format = html_format + "{" + values + "}"
    dbkey = d_datas.shift()
  when "db_listbox"
    d_sql = []
    d_sql << "table:" + d_datas.shift()
    d_sql << "data:" + d_datas.shift()
    cc = 1
    db_key = ""
    for ww in d_datas
	    STDERR.print "ww=",ww,"\n"
      if ( ww == "dbkey" ) then
        dbkey = ww.dup
      else
         d_sql << "where#{cc}:" + ww
      end
      cc += 1
    end
    ff = d_sql.join(",")

    html_format = html_format + "{" + ff + "}"

  else

  end 

  if ( dbkey == "dbkey" ) then
    html_format = html_format + "." + dbkey
  end
  	STDERR.print "html_format=",html_format,"\n"
  return format_key, html_format
end
#
#
#
def set_format_sheet( table )

  h_format = Hash.new()
  table.elements.collect("table:table-row") {| row |
    ro = row.attributes.get_attribute("table:style-name").value
      ##STDERR.print row,"\n"
    	
    d_datas = []
    html_flag = false
    row.elements.collect("table:table-cell") {| cell |
      
      text_data = get_cel_text(cell)
      if ( text_data =~ /^@/ ) then
        html_flag = true
      end 
      if ( html_flag == true ) then
        if ( text_data != nil ) then
          d_datas << text_data
	end
      end
    }
    	##print d_datas.size,"\n"
    next if d_datas.size == 0
    format_key,html_format = set_format( d_datas )
    	STDERR.print "                    ",format_key,"=",html_format,"\n"
    h_format[format_key] = html_format

  }

  return h_format

end
#
# sheet毎 処理
#  sheet 毎に h_id_text に追加していく
#
##def sheet_data( table ,h_format, h_id_text)
def sheet_data( table ,h_id_text)


#  h_format = Hash.new()	  #	@text.#text
#  h_id_text = Hash.new()  #	#text.text11
  table.elements.collect("table:table-row") {| row |
    ro = row.attributes.get_attribute("table:style-name").value
    	
    row.elements.collect("table:table-cell") {| cell |
      
        data = get_cel_text(cell)

        case data
        when /^#/
          format_key,xml_id = data.sub(/^#/, "").split(".")
          h_id_text[data] = format_key	# {text1: #text.text11, ....
        #when /^@/
        #  format_key,html_format = data.sub(/^@/, "").split(".")
	#  html_format.sub!(/^#/,"")
        #  h_format[format_key] = html_format #{ text1: text , date1: data..
        end

    } #end of cell loop
  }  # end of row ooop
  return h_id_text
end   # end of teble
#
#  エラーの場合のみ h_errorにデータが入る。
#
def check_format(h_format,h_id_text )

  flag = true
  h_error = Hash.new()
  h_id_text.each do |data, format_key|		#
    if ( h_format[format_key] == nil ) then
      flag= false
      h_error[data] = "no format"
    end
    	
    STDERR.print data,"= ",h_format[format_key],"\n"
  end
  return flag,h_error
end
#
#  check [save] [load] button
#
def check_db_save_load( h_format, h_id_text )
    STDERR.print "****  exec check_save_load\n"

  save_flag = false
  load_flag = false
  h_error = Hash.new()
  h_error["save_button"] = "no save_button"
  h_error["load_button"] = "no load_button"

  h_id_text.each do |data, format_key|		#
    if ( h_format[format_key] =~ /save_button/) then
      save_flag = true
      	
    end
    if ( h_format[format_key] =~ /load_button/) then
      load_flag = true
    end
    	
    STDERR.print data,"= ",h_format[format_key]," format_key=",format_key,"\n"
  end
  #
  flag = false
  if ( load_flag == true && save_flag == true ) then
    flag = true
    h_error = Hash.new()	# clear h_error
  end

STDERR.print "check_dbsave_load flag== ", flag,"\n"
STDERR.print "check_dbsave_load h_error= ",h_error,"\n"

  return flag,h_error
end
#
#  table名が定義されているかチェックする。
#
def check_table( h_format, h_id_text )
  flag = true
  h_error = Hash.new()	# clear h_error
  table_name = nil
  h_id_text.each do |data, format_key|		#
    if ( h_format[format_key] =~ /db_table\{(.+)\}/) then
      table_name = $1
    end
  end

  if ( table_name == nil ) then
	h_error["table_name"] = "テーブル名が設定されていません!!" 
	flag = false
	return flag,h_error
  end
  
  return flag,h_error

end

end # End of module_function PharmaODS
############################################################################
#
#  main
#
############################################################################
if __FILE__ == $0
#
require "zip/zipfilesystem"
#
#PharmaODS.init()


file_name = ARGV.shift()
ext = File.extname(file_name)

doc = nil
if ( ext =~ /xml$/ ) then
  File.open(file_name) {|xmlfile|
    doc = REXML::Document.new(xmlfile)
  }

elsif ( ext =~/ods$/ ) then

  docbytes = nil
  Zip::ZipFile.open(file_name) do |zipfile|
    docbytes = zipfile.file.read('content.xml')
  end
  doc = REXML::Document.new(docbytes)

end


h_format = Hash.new()	  #	@text.#text
h_id_text = Hash.new()  #	#text.text11
office_body = doc.elements["//office:spreadsheet"]
#
# check format
if ( office_body == nil ) then
  msg = "<error>illiga document format</error>"
  flag = false
  print flag,"\n",msg,"\n"
  exit
end

format_flag = false

office_body.elements.collect("//table:table") { | table |
	
   sheet_name = table.attributes.get_attribute('table:name').value
         STDERR.print "   sheet_name=",sheet_name,"\n"

   if ( sheet_name =~ /format_sheet/ ) then
     h_format = PharmaODS.set_format_sheet( table )
     format_flag = true
   else
     #h_format,h_id_text = PharmaODS.sheet_data( table, h_format, h_id_text )
     h_id_text = PharmaODS.sheet_data( table, h_id_text )
   end

}
#
if ( format_flag == false ) then
        print false,"\n"
	print "format_sheet がありません\n"
	exit
end
#
#
#
flag_0,h_error_0 = PharmaODS.check_format(h_format,h_id_text )
flag_1,h_error_1 =  PharmaODS.check_db_save_load( h_format, h_id_text )
flag_2,h_error_2 =  PharmaODS.check_table( h_format, h_id_text )
if ( flag_0 == true && flag_1 == true && flag_2 == true ) then
        print true,"\n"
	print ""
	#print h_format.to_json
else

        print false,"\n"
	h_error = h_error_0.merge(h_error_1)
	h_error = h_error.merge(h_error_2)
	print h_error.to_json
end

end # end of Main
